<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Task 35.50</title>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách người dùng</h2>

        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    //{id: 13707, firstname: 'Phuong', lastname: 'Nguyen', country: 'Vietnam', subject: 'Medical', …}
    $(document).ready(function () {
        onPageLoading();
        const gDATA_COLUMN = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
        const gID_COL = 0;
        const gFIRST_NAME_COL = 1;
        const gLAST_NAME_COL = 2;
        const gCOUNTRY_COL = 3;
        const gSUBJECT_COL = 4;
        const gCUSTOMER_TYPE_COL = 5;
        const gREGISTEER_STATUS_COL = 6;
        const gACTION_COL = 7;

        $("#user-table").DataTable({
            columns: [
                { data: gDATA_COLUMN[gID_COL] },
                { data: gDATA_COLUMN[gFIRST_NAME_COL] },
                { data: gDATA_COLUMN[gLAST_NAME_COL] },
                { data: gDATA_COLUMN[gCOUNTRY_COL] },
                { data: gDATA_COLUMN[gSUBJECT_COL] },
                { data: gDATA_COLUMN[gCUSTOMER_TYPE_COL] },
                { data: gDATA_COLUMN[gREGISTEER_STATUS_COL] },
                { data: gDATA_COLUMN[gACTION_COL] },
            ],
            columnDefs: [
                {
                    targets: gACTION_COL,
                    defaultContent: "<button class = 'btn btn-primary btn-detail'>Chi tiết</button>"
                }
            ]

        })
        $(document).on("click","#user-table .btn-detail",function(){
            onBtnDetailClick(this)
        })

        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
                type: "GET",
                dataType: 'json',
                success: function (pagram) {

                    loadData(pagram)
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText)
                }


            })
        }

        // hàm load data và bảng 
        function loadData(pagram) {
            var vTable = $("#user-table").DataTable();
            vTable.clear();
            vTable.rows.add(pagram);
            vTable.draw()
        }
        // hàm ấn nút chi tiết 
        function onBtnDetailClick(pagramElement) {
            var vRowClick = $(pagramElement).closest("tr")
            var vTable = $("#user-table").DataTable();
            var vDataRow = vTable.row(vRowClick).data();
         console.log("User ID là: " + vDataRow.id);
         console.log("User Fistname là: " + vDataRow.firstname);
         console.log("User Lastname là: " + vDataRow.lastname);
         console.log("User Country là: " + vDataRow.country);
         console.log("User Subject là: " + vDataRow.subject);
         console.log("User Customer Type là: " + vDataRow.customerType);
         console.log("User Register Status là: " + vDataRow.registerStatus);


        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    })
</script>

</html>